
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: C_Container, NUM_BAG_SLOTS, tonumber

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Automation Sell")

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

function M:OnEnable()
	self:RegisterEvent("MERCHANT_SHOW")
end

-------------------------------------------------------------------------------
-- Ignore List
-------------------------------------------------------------------------------

function M:GetIgnoreList()
	return self.config.blacklist
end

function M:Ignore(value)
	for itemLink, itemID in value:gmatch("(|c[^|]+|Hitem:(%d+):[^|]+|h%[.-%]|h|r)") do
		self.config.blacklist[tonumber(itemID)] = itemLink
	end
end

function M:IsIgnored(itemID)
	return self.config.blacklist[itemID] ~= nil
end

function M:Unignore(itemID)
	self.config.blacklist[itemID] = nil
end

-------------------------------------------------------------------------------
-- Events
-------------------------------------------------------------------------------

-- Sell the player's poor quality items.
function M:MERCHANT_SHOW()
	for container = 0, NUM_BAG_SLOTS do
		for slot = 1, C_Container.GetContainerNumSlots(container) do
			local itemInfo = C_Container.GetContainerItemInfo(container, slot)

			if itemInfo and itemInfo.quality == 0 and not self:IsIgnored(itemInfo.itemID) then
				C_Container.UseContainerItem(container, slot)
			end
		end
	end
end
